// Global implemented and various bug fixes by Trevor Hobson
const nsIFilePicker = Components.interfaces.nsIFilePicker;
var timerID = 0;
var tStart  = null;


var objbp = {
	objectionPrefs: Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.objection."),
	objectStrings: '',
	optionflashAppDir: '',
	lsos: [],
	deletedLsos: [],
	count: 0,
	lsosTree: null,
	lastLsoSortColumn: '',  
	lastLsoSortAscending: false,
	LSORoot: "",//nc
	dirArray: null,


	LOG: function(text)
	{
	    var consoleService = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);
	    consoleService.logStringMessage(text);
	},



	lsosTreeView:
	{
		rowCount: 0,
		setTree: function(tree) {},
		getImageSrc: function(row, column) {},
		getProgressMode: function(row, column) {},
		getCellValue: function(row, column) {},
		getCellText: function(row, column) {
			var rv="";
			if (column.id=="parentCol") // Added .id TH
			{
				rv = objbp.lsos[row].parent;
			}
			else if (column.id=="nameCol") // Added .id TH
			{
				rv = objbp.lsos[row].name;
			}
			return rv;
		},
		isSeparator: function(index) {return false;},
		isSorted: function() {return false;},
		isContainer: function(index) {return false;},
		cycleHeader: function(aColId, aElt) {},
		getRowProperties: function(row, props) {},
		getColumnProperties: function(column, props) {},
		getCellProperties: function(row, column, props) {},
	},

	AutoIntervalToggled: function()
	{
			if(document.getElementById("AutoDelIntervalPref").checked == false){
				document.getElementById("AutoDelIntervalDelayPref").disabled = true;
				document.getElementById("delIntervallabel").disabled = true;
				document.getElementById("delInterval").disabled = true;
				document.getElementById("unitList").disabled = true;
			}else{
				document.getElementById("AutoDelIntervalDelayPref").disabled = false;
				document.getElementById("delIntervallabel").disabled = false;
				document.getElementById("delInterval").disabled = false;
				document.getElementById("unitList").disabled = false;
			}
	},

	objection_init: function()
	{

		// Read string bundle set
		objbp.objectStrings = document.getElementById('lsoStrings');

		// Reference the tree
		objbp.lsosTree = document.getElementById('lsosTree');

		// Display error if selected directory does not exist
		var checkFlashDir = GetFlashDir(0);
		if (checkFlashDir.path == "")
		{
			document.getElementById("appdir").value = objbp.objectStrings.getString("dirNotFound");
			document.getElementById("appdir").style.backgroundColor = "red";
			document.getElementById("appdir").style.color = "white";
		}
		else
		{
			document.getElementById("appdir").value = checkFlashDir.path;
			document.getElementById("appdir").style.backgroundColor = "";
			document.getElementById("appdir").style.color = "";
			objbp.loadLsos(checkFlashDir);
		}
		if( navigator.preference("extensions.objection.domstorage.allowed") != navigator.preference("dom.storage.enabled")
		|| navigator.preference("extensions.objection.sendpings.allowed") != navigator.preference("browser.send_pings") )
		{
			if(confirm("BetterPrivacy:\r\nThe extension detected that one or more privacy settings have been modified!\r\nPress OK to correct those values.")){
				navigator.preference("dom.storage.enabled", navigator.preference("extensions.objection.domstorage.allowed"));
				navigator.preference("browser.send_pings", navigator.preference("extensions.objection.sendpings.allowed"));
			}
		}
		var interval = navigator.preference("extensions.objection.DelTimerInterval");
		var selidx = 2;
		var val = 1;
		if(interval % 86400 == 0){//days
			val = interval / 86400;
			selidx = 3;
		}else if(interval % 3600  == 0){ //hours
			val = interval / 3600;
			selidx = 2;
		}else if(interval % 60 == 0){ //minutes
			val = interval / 60;
			selidx = 1;
		}else if(interval >= 1){
			val = Math.round(interval);
			selidx = 0;
		}
		document.getElementById("delInterval").value = val;
		document.getElementById("unitList").selectedIndex = selidx;
		objbp.AutoIntervalToggled();
	},


	objection_onload: function()
	{
		var objectionPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.objection.");
		if(!navigator.preference("extensions.objection.initiated")){
			navigator.preference("browser.send_pings", false)
			navigator.preference("dom.storage.enabled", false)
			navigator.preference("extensions.objection.domstorage.allowed", false)
			navigator.preference("extensions.objection.sendpings.allowed", false)
			navigator.preference("extensions.objection.initiated", true)
		}

		if( navigator.preference("extensions.objection.domstorage.allowed") != navigator.preference("dom.storage.enabled")
		|| navigator.preference("extensions.objection.sendpings.allowed") != navigator.preference("browser.send_pings") )
		{
			if(confirm("BetterPrivacy:\r\nThe extension detected that one or more privacy settings have been modified!\r\nPress OK to correct those values.")){
				navigator.preference("dom.storage.enabled", navigator.preference("extensions.objection.domstorage.allowed"));
				navigator.preference("browser.send_pings", navigator.preference("extensions.objection.sendpings.allowed"));
			}
		}

		if(navigator.preference("extensions.objection.DelTimerInterval") < 1)
			navigator.preference("extensions.objection.DelTimerInterval", 1);
		objbp.objectionPrefs.setIntPref("removed", 0);

		if(navigator.preference("extensions.objection.AutoDelLSO"))
				objbp.objection_autoDel(false);

		objbp.startDelTimer();

	},//end menue load



	objection_parseDirs: function(currentDir)
	{
		var entries = currentDir.directoryEntries;
		while(entries.hasMoreElements())
		{
			try{
					var entry = entries.getNext();
					entry.QueryInterface(Components.interfaces.nsIFile);
					if (entry.isDirectory()){
						objbp.dirArray.push(entry);
					objbp.objection_parseDirs(entry);
				}
			}catch(e){objbp.LOG("BetterPrivacy: Failure parsing directories - " + e);}
		}
	},



	getsortpos: function(file1, file2)
	{
			if (file1.path.length > file2.path.length)
			return -1;
			else if (file2.path.length > file1.path.length)
			return 1;
			return 0;
	},


	objection_delDirs: function(buDirRoot)
	{
		if(!navigator.preference("extensions.objection.delDirs"))
			return;
	  // Delete ISO8601 formated directories 
		objbp.dirArray = new Array();
		objbp.objection_parseDirs(buDirRoot);
		var numDirsToDelete = objbp.dirArray.length;
		objbp.dirArray.sort(objbp.getsortpos);
		for(var i=0; i<numDirsToDelete; i++){
			try{ //never delete non-empty directories (FF throws NS_ERROR_FILE_DIR_NOT_EMPTY if remove attribut is false)
				objbp.dirArray[i].remove(false);
			}catch(e){
				if(e.name == "NS_ERROR_FILE_DIR_NOT_EMPTY")
					objbp.LOG("BetterPrivacy: Refusing to delete non-empty directory - " + objbp.dirArray[i].path);
				else
					objbp.LOG("BetterPrivacy: Unable to delete directory - " + objbp.dirArray[i].path + " - " + e);
				}
		}
		objbp.dirArray = null;
	},





	objection_autoDel: function(byTimer)
	{
			var objectionPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.objection.");	
			// Read string bundle set
			objbp.objectStrings = document.getElementById('lsoStrings');
				// Reference the tree
			objbp.lsosTree = document.getElementById('lsosTree');

			var checkFlashDir = GetFlashDir(0);
			if(checkFlashDir.path == "" && !byTimer && !navigator.preference("extensions.objection.DisableFlashDirAutoScan")){
					checkFlashDir = GetFlashDir(1);
			}

			if (checkFlashDir.path != "")
			{
				objbp.count = 0;
				objbp.lsos = new Array();
				objbp.loadLsosSub(checkFlashDir, checkFlashDir.path);
				objbp.lsosTreeView.rowCount = objbp.lsos.length;
				// Work around for the problem below, sort the array first
				objbp.lastLsoSortAscending = objbp.SortTreeArray(objbp.lsos, 'parent', objbp.lastLsoSortColumn, objbp.lastLsoSortAscending);
				objbp.lastLsoSortColumn = 'parent';
				// End workaround

				var deleted = 0;
				for (var x=0;x<objbp.lsos.length;x++)
				{
					try{
						var defaultCookie = false;
						if( objbp.lsos[x].file.leafName.toLowerCase() == "settings.sol" && objbp.lsos[x].file.path.toLowerCase().indexOf("macromedia.com") != -1 )
							defaultCookie = true;
						if(!defaultCookie || navigator.preference("extensions.objection.DefaultFlashCookieDeletion")){

								var cDate = new Date();
								if( byTimer && navigator.preference("extensions.objection.useDelTimerDelay") && cDate.getTime() >= objbp.lsos[x].file.lastModifiedTime && cDate.getTime()-objbp.lsos[x].file.lastModifiedTime < navigator.preference("extensions.objection.DelTimerInterval") * 1000 )
									continue;
								objbp.lsos[x].file.remove(false);
								deleted++;
						}
					}catch(e){}
				}
				objbp.objection_delDirs(checkFlashDir);
				objbp.objectionPrefs.setIntPref("removed", objbp.objectionPrefs.getIntPref("removed") + deleted);
			}
			/*
				if(navigator.preference("extensions.objection.AutoDelDOM") && navigator.preference("dom.storage.enabled")){
					var file = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("ProfD", Components.interfaces.nsIFile);
					file.append("webappsstore.sqlite");
					if(file.exists()){    // if it exists, delete
						try{
							file.remove(false);
							objbp.objectionPrefs.setIntPref("removed", x+1);
						}catch(e){alert(e);}
		
					}
				}//end AutoDelDOM
			*/
	},



	startDelTimer: function() 
	{

		tStart = new Date();
		objbp.updateDelTimer();
	},

	stopDelTimer: function() 
	{
		if(timerID) {
			clearTimeout(timerID);
			timerID  = 0;
		}
		tStart = null;
	},

	updateDelTimer: function() 
	{
		if(timerID) 
			clearTimeout(timerID);
		if(!tStart)
			tStart = new Date();
		var tDate = new Date();
		tDate.setTime(tDate.getTime() - tStart.getTime());
		if(tDate.getTime() / (navigator.preference("extensions.objection.DelTimerInterval") * 1000) >= 1){
			if(navigator.preference("extensions.objection.useDelTimer"))
				objbp.objection_autoDel(true);
			tStart = null;
		}
		timerID = setTimeout("objbp.updateDelTimer()", 1000);
	},


	changeAppDir: function()
	{
		var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);

		fp.init(window, objbp.objectStrings.getString("selectDirTitle"), nsIFilePicker.modeGetFolder);
		var rv = fp.show();
		if (rv == nsIFilePicker.returnOK || rv == nsIFilePicker.returnReplace)
		{
			var file = fp.file;
			if (document.getElementById("appdir").value != file.path)
			{
				document.getElementById("appdir").value = file.path;
				document.getElementById("appdir").style.backgroundColor = "";
				document.getElementById("appdir").style.color = "";
				objbp.objectionPrefs.setCharPref("flashAppDir", file.path);
				objbp.loadLsos(file);
			}
		}
	},

	searchAutomatic: function()
	{
		// Display error if selected directory does not exist
		var checkFlashDir;

		if(document.getElementById("ScanHD").checked == true)
			checkFlashDir = GetFlashDir(3);
		else if(document.getElementById("IgnoreDefault").checked == true)
			checkFlashDir = GetFlashDir(2);
		else
			checkFlashDir = GetFlashDir(1);

		if (checkFlashDir.path == "")
		{
			document.getElementById("appdir").value = objbp.objectStrings.getString("dirNotFound");
			document.getElementById("appdir").style.backgroundColor = "red";
			document.getElementById("appdir").style.color = "white";
		}
		else
		{
			document.getElementById("appdir").value = checkFlashDir.path;
			document.getElementById("appdir").style.backgroundColor = "";
			document.getElementById("appdir").style.color = "";
			objbp.loadLsos(checkFlashDir);
		}
	},

	Lso: function(number, file, name, size, path, parent, pathFlash)
	{
		this.number = number;
		this.file = file;
		this.name = name;
		this.size = size;
		this.path = path;
		this.pathShort = '...' + path.substr(pathFlash.length);
		this.parent = parent;
		return this;
	},

	loadLsos: function(flashDir)
	{
		objbp.count = 0;
		objbp.lsos = new Array();
		objbp.loadLsosSub(flashDir, flashDir.path);
		objbp.lsosTreeView.rowCount = objbp.lsos.length;
// Work around for the problem below, sort the array first
		objbp.lastLsoSortAscending = objbp.SortTreeArray(objbp.lsos, 'parent', objbp.lastLsoSortColumn, objbp.lastLsoSortAscending);
		objbp.lastLsoSortColumn = 'parent';
// End workaround
		objbp.lsosTree.view = objbp.lsosTreeView;
		document.getElementById("removeAllLsos").disabled = objbp.lsos.length == 0;
		document.getElementById("lso_removed").value = navigator.preference("extensions.objection.removed");
	},

	loadLsosSub: function(currentDir, flashPath)
	{
		var entries = currentDir.directoryEntries;
		while(entries.hasMoreElements())
		{
			try{
				var entry = entries.getNext();
				entry.QueryInterface(Components.interfaces.nsIFile);
				if (entry.isFile())
				{
					try{
						var leaf  = entry.leafName;
						var dotIndex  = leaf.lastIndexOf('.');
						var extension = (dotIndex >= 0) ? leaf.substring(dotIndex+1) : "";
						if ((extension == "sol")||(extension == "fso"))
						{
							objbp.lsos[objbp.count] = new objbp.Lso(objbp.count++, entry, entry.leafName, entry.fileSize, entry.path, entry.parent.leafName, flashPath);
						}
					}catch(e){}
				}
				else if (entry.isDirectory())
				{
					objbp.loadLsosSub(entry, flashPath);
				}
			}catch(e){}
		}
	},

//-------------------------------------------------------------------------------------------------------------------------

	FindLSORoot: function(ForceSearch)
	{
		try{
				var HomeDir = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("Home", Components.interfaces.nsILocalFile);
				if(ForceSearch == 3){

					if(!confirm("You are about to start a full partition scan to find the Flash cookie folder.\r\nDepending on the partition size this may need several minutes or even hours!\r\nFIREFOX WILL NOT REACT WHILE THE SCAN IS DONE, THERE IS NO ABORT.\r\n\r\nAre you really sure to start the scan?\r\n(Press Cancel to abort)"))
						return objbp.LSORoot;

					HomeDirPath = HomeDir.path.slice(0, 3);
					var hdir = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
					hdir.initWithPath(HomeDirPath);
					HomeDir = hdir;
				}
				var runTime = navigator.preference("dom.max_chrome_script_run_time");
				navigator.preference("dom.max_chrome_script_run_time", 3600);


				objbp.FindLSORootSub(HomeDir, 0);


				navigator.preference("dom.max_chrome_script_run_time", runTime);
				if(objbp.LSORoot != ""){
					var testPath = objbp.LSORoot.toLowerCase();
					while(testPath.indexOf("flash") != -1 || testPath.indexOf("macromedia") != -1)
					{
							objbp.LSORoot = testPath;
							var pos = testPath.lastIndexOf("\\");
							if(pos < 1)
								pos = testPath.lastIndexOf("/");
							if(pos > 0)
								testPath = testPath.slice(0, pos);
							else break;
					}
				}
		}catch(e){;}
		return objbp.LSORoot;
	},

	FindLSORootSub: function(currentDir, errors)
	{
		if(errors > 10){
			return;
		}
		var entries = currentDir.directoryEntries;
		while(entries.hasMoreElements())
		{
			try{
				var entry = entries.getNext();
				entry.QueryInterface(Components.interfaces.nsIFile);
				if (entry.isFile())
				{
					try{
						var leaf  = entry.leafName;
						var dotIndex  = leaf.lastIndexOf('.');
						var extension = (dotIndex >= 0) ? leaf.substring(dotIndex+1) : "";
						var currentPath = String(currentDir.path).toLowerCase();
						if ((extension.toLowerCase() == "sol")||(extension.toLowerCase() == "fso"))
						{
								if( (currentPath.length < objbp.LSORoot.length || objbp.LSORoot == "") && (currentPath.indexOf("flash") != -1 || currentPath.indexOf("macromedia") != -1) ){
									objbp.LSORoot = currentPath;
								}
						}
					}catch(e){errors++;}
				}
				else if (entry.isDirectory()){
					objbp.FindLSORootSub(entry, errors);
				}
			}catch(e){errors++;}
		}
	},

//-------------------------------------------------------------------------------------------------------------------------

	LsoColumnSort: function(column)
	{
		objbp.lastLsoSortAscending = objbp.SortTree(objbp.lsosTree, objbp.lsosTreeView, objbp.lsos, column, objbp.lastLsoSortColumn, objbp.lastLsoSortAscending, true);
		objbp.lastLsoSortColumn = column;
	},

	LsoSelected: function()
	{
		var selections = objbp.GetTreeSelections(objbp.lsosTree);
		if (selections.length)
		{
			document.getElementById("removeLso").removeAttribute("disabled");
		}
		else
		{
		return true;
		}
		var indexvar = selections[0];
		if (indexvar >= objbp.lsos.length)
		{
			// Something got out of sync.  See bug 119812 for details (Included from original code, bug has been fixed but keep to be safe - TH)
			return;
		}
		if (selections.length > 1)
		{
			objbp.SetLsoProperties("", "", "", "");
		}
		else
		{
			objbp.SetLsoProperties(objbp.lsos[indexvar].name, objbp.lsos[indexvar].parent, objbp.lsos[indexvar].size + " bytes", objbp.lsos[indexvar].pathShort);
		}
		return true;
	},

	HandleLsoKeyPress: function(e)
	{
		if (e.keyCode == 46)
		{
			objbp.DeleteLso();
		}
	},

	DeleteLso: function()
	{
		var toDelete = objbp.GetTreeSelections(objbp.lsosTree);
		var deleted = 0;
		for (var x=0;x<toDelete.length;x++)
		{	
			try{
				objbp.lsos[toDelete[x]].file.remove(false);
				deleted++;
			}catch(e){}
		}
		objbp.objection_delDirs(GetFlashDir(0));
		//navigator.preference("extensions.objection.currentCookieCount", objbp.lsos.length-deleted);
		objbp.DeleteSelectedItemFromTree(objbp.lsosTree, objbp.lsosTreeView, objbp.lsos, objbp.deletedLsos, "removeLso", "removeAllLsos");
		if (!objbp.lsos.length)
		{
			objbp.SetLsoProperties("", "", "", "");
		}
	},

	DeleteAllLsos: function()
	{
		var deleted = 0;
		for (var x=0;x<objbp.lsos.length;x++)
		{
			try{
				objbp.lsos[x].file.remove(false);
				deleted++;
			}catch(e){}
		}
		objbp.objection_delDirs(GetFlashDir(0));
		//navigator.preference("extensions.objection.currentCookieCount", objbp.lsos.length-deleted);
		objbp.DeleteAllFromTree(objbp.lsosTree, objbp.lsosTreeView, objbp.lsos, objbp.deletedLsos, "removeLso", "removeAllLsos");
		objbp.SetLsoProperties("", "", "", "");
	},

	SetLsoProperties: function(lso_name, lso_parent, lso_size, lso_path)
	{
		document.getElementById("lso_name").value = lso_name;
		document.getElementById("lso_parent").value = lso_parent;
		document.getElementById("lso_size").value = lso_size;
		document.getElementById("lso_path").value = lso_path;
		//var objectionPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.objection.");	
		//document.getElementById("lso_removed").value = objbp.objectionPrefs.getIntPref("removed");
	},

// Code below inserted from http://www.fiveanddime.net/firefox-1.5-source/mozilla/toolkit/components/passwordmgr/resources/content/passwordManager.js.html
// as I could not find these functions in the current chrome - Trevor Hobson

	DeleteAllFromTree: function(tree, view, table, deletedTable, removeButton, removeAllButton)
	{
		// remove all items from table and place in deleted table
		for (var i=0; i<table.length; i++)
		{
			deletedTable[deletedTable.length] = table[i];
		}
		table.length = 0;

		// clear out selections
		view.selection.select(-1); 

		// update the tree view and notify the tree
		view.rowCount = 0;

		var box = tree.treeBoxObject;
		box.rowCountChanged(0, -deletedTable.length);
		box.invalidate();

		// disable buttons
		document.getElementById(removeButton).setAttribute("disabled", "true")
		document.getElementById(removeAllButton).setAttribute("disabled","true");
	},

	DeleteSelectedItemFromTree: function(tree, view, table, deletedTable, removeButton, removeAllButton)
	{
		var box = tree.treeBoxObject;

		// Remove selected items from list (by setting them to null) and place in
		// deleted list.  At the same time, notify the tree of the row count changes.
		var selection = box.view.selection;
		var oldSelectStart = table.length;
		box.beginUpdateBatch();

		var selCount = selection.getRangeCount();
		var min = new Object();
		var max = new Object();

		for (var s = 0; s < selCount; ++s)
		{
			selection.getRangeAt(s, min, max);
			var minVal = min.value;
			var maxVal = max.value;

			oldSelectStart = minVal < oldSelectStart ? minVal : oldSelectStart;

			var rowCount = maxVal - minVal + 1;
			view.rowCount -= rowCount;
			box.rowCountChanged(minVal, -rowCount);

			for (var i = minVal; i <= maxVal; ++i)
			{
				deletedTable[deletedTable.length] = table[i];
				table[i] = null;
			}
		}

		// collapse list by removing all the null entries
		for (var j = 0; j < table.length; ++j)
		{
			if (!table[j])
			{
				var k = j;
				while (k < table.length && !table[k])
				k++;
				table.splice(j, k-j);
			}
		}

		box.endUpdateBatch();

		// update selection and/or buttons
		var removeBtn = document.getElementById(removeButton);
		var removeAllBtn = document.getElementById(removeAllButton);

		if (table.length)
		{
			removeBtn.removeAttribute("disabled");
			removeAllBtn.removeAttribute("disabled");

			selection.select(oldSelectStart < table.length ? oldSelectStart : table.length - 1);
		}
		else
		{
			removeBtn.setAttribute("disabled", "true");
			removeAllBtn.setAttribute("disabled", "true");
		}
	},

	GetTreeSelections: function(tree)
	{
		var selections = [];
		var select = tree.view.selection;
		if (select)
		{
			var count = select.getRangeCount();
			var min = new Object();
			var max = new Object();
			for (var i=0; i<count; i++)
			{
				select.getRangeAt(i, min, max);
				for (var k=min.value; k<=max.value; k++)
				{
					if (k != -1)
					{
						selections[selections.length] = k;
					}
				}
			}
		}
		return selections;
	},

	// Split original into two functions (SortTree and SortTreeArray) so can sort the array before applying to tree mainly for FF3 null issue
	SortTree: function(tree, view, table, column, lastSortColumn, lastSortAscending, updateSelection)
	{
		// remember which item was selected so we can restore it after the sort
		var selections = objbp.GetTreeSelections(tree);
		var selectedNumber = selections.length ? table[selections[0]].number : -1;

		// sort the table (array)
		var ascending = objbp.SortTreeArray(table, column, lastSortColumn, lastSortAscending);

		// restore the selection
		var selectedRow = -1;
		if (selectedNumber>=0 && updateSelection)
		{
			for (var s=0; s<table.length; s++)
			{
				if (table[s].number == selectedNumber)
				{
					// update selection
					// note: we need to deselect before reselecting in order to trigger ...Selected()
					tree.view.selection.select(-1);
					tree.view.selection.select(s);
					selectedRow = s;
					break;
				}
			}
		}

		// display the results
		tree.treeBoxObject.invalidate();
		if (selectedRow >= 0)
		{
			tree.treeBoxObject.ensureRowIsVisible(selectedRow)
		}

		return ascending;
	},

	SortTreeArray: function(table, column, lastSortColumn, lastSortAscending)
	{
		// determine if sort is to be ascending or descending
		var ascending = (column == lastSortColumn) ? !lastSortAscending : true;

		// do the sort
		var compareFunc;
		if (ascending)
		{
			compareFunc = function compare(first, second)
			{
				return objbp.CompareLowerCase(first[column], second[column]);
			}
		}
		else
		{
			compareFunc = function compare(first, second)
			{
				return objbp.CompareLowerCase(second[column], first[column]);
			}
		}

		table.sort(compareFunc);
		return ascending;
	},

	// Case insensitive string comparator.
	CompareLowerCase: function(first, second)
	{
		var firstLower  = first.toLowerCase();
		var secondLower = second.toLowerCase();

		if (firstLower < secondLower)
		{
			return -1;
		}

		if (firstLower > secondLower)
		{
			return 1;
		}

		return 0;
	},
// End imported code
};





// automatic detection for Flash Apps directory
function GetFlashDir(ForceSearch)
{
	//ForceSearch=0: Try 'standard places' only if no preference exists (user may have set directory manually)
	//ForceSearch=1: Ignore current preference: Try 'standard places' and if no result do 'user homedir scan'
	//ForceSearch=2: Ignore current preference, ignore 'standard places': Try 'user homedir scan'
	//ForceSearch=3: Ignore current preference, do not use 'standard places': Try a 'full hard disk scan'
	var objectionPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.objection.");
	var flashDir;
	var knownDir = "";
	var pc = "win32";
	try{
		pc = String(window.navigator.platform).toLowerCase();
	}catch(e){;}


	try{

		if ( objectionPrefs.prefHasUserValue(ForceSearch == 0 && "flashAppDir") && objectionPrefs.getCharPref("flashAppDir") != undefined && objectionPrefs.getCharPref("flashAppDir") != "" )
			knownDir = objectionPrefs.getCharPref("flashAppDir");

		if (pc.indexOf("win32") != -1) //windows
		{

			if ( knownDir == "" && ForceSearch < 2 )
			{
					flashDir = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("AppData", Components.interfaces.nsILocalFile);
					flashDir.append("Roaming");
					flashDir.append("Macromedia");
					flashDir.append("Flash Player");
					if ( flashDir.exists() && flashDir.isDirectory() )
						knownDir = flashDir.path;
			}
			if ( knownDir == "" && ForceSearch < 2 )
			{
					flashDir = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("AppData", Components.interfaces.nsILocalFile);
					flashDir.append("Macromedia");
					flashDir.append("Flash Player");
					if ( flashDir.exists() && flashDir.isDirectory() )
						knownDir = flashDir.path;
			}
			if ( knownDir == "" && ForceSearch > 1)
						knownDir = objbp.FindLSORoot(ForceSearch);
		}
		else if (pc.indexOf("mac") != -1) //mac
		{
			if ( knownDir == "" && ForceSearch < 2 )
			{
					flashDir = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("UsrPrfs", Components.interfaces.nsILocalFile);
					flashDir.append("Library");
					flashDir.append("Preferences");
					flashDir.append("Macromedia");
					flashDir.append("Flash Player");
					if ( flashDir.exists() && flashDir.isDirectory() )
						knownDir = flashDir.path;
			}
			if ( knownDir == "" && ForceSearch > 1 )
						knownDir = objbp.FindLSORoot(ForceSearch);
		}
		else //linux or other
		{
			if ( knownDir == "" && ForceSearch < 2 )
			{
					flashDir = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("Home", Components.interfaces.nsILocalFile);
					flashDir.append(".macromedia");
					flashDir.append("Flash_Player");
					if ( flashDir.exists() && flashDir.isDirectory() )
						knownDir = flashDir.path;
			}
			if ( knownDir == "" && ForceSearch < 2 )
			{
					flashDir = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("Home", Components.interfaces.nsILocalFile);
					flashDir.append(".macromedia");
					if ( flashDir.exists() && flashDir.isDirectory() )
						knownDir = flashDir.path;
			}
			if ( knownDir == "" && ForceSearch > 1 )
						knownDir = objbp.FindLSORoot(ForceSearch);
		}

	}catch(e){;}

	var Dir = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
	if(knownDir != "")
		Dir.initWithPath(knownDir);
	if(Dir.path != "")
		objectionPrefs.setCharPref("flashAppDir", Dir.path);

	if(document.getElementById("IgnoreDefault")) document.getElementById("IgnoreDefault").disabled = false;
	if(document.getElementById("IgnoreDefault")) document.getElementById("IgnoreDefault").checked = false;
	if(document.getElementById("ScanHD")) document.getElementById("ScanHD").checked = false;

  return Dir;

}